diff --git a/drupal7/sites/all/modules/media/modules/media_wysiwyg/js/media_wysiwyg.format_form.js b/drupal7/sites/all/modules/media/modules/media_wysiwyg/js/media_wysiwyg.format_form.js
index f9b16f43..4345a345 100644
--- a/drupal7/sites/all/modules/media/modules/media_wysiwyg/js/media_wysiwyg.format_form.js
+++ b/drupal7/sites/all/modules/media/modules/media_wysiwyg/js/media_wysiwyg.format_form.js
@@ -42,12 +42,12 @@ Drupal.media.formatForm.getOptions = function () {
       field.name = field.name.replace(/\[format\]/i, '[value]');
       field.key  = 'edit-' + field.name.replace(/[_\[]/g, '-').replace(/[\]]/g, '');
 
-      if (Drupal.wysiwyg.instances[field.key]) {
+      if (Drupal.wysiwyg && Drupal.wysiwyg.instances[field.key]) {
         // Retrieve the content from the WYSIWYG instance.
         ret[field.name] = Drupal.wysiwyg.instances[field.key].getContent();
 
-        // Escape the double-quotes and encode it to play nicely within JSON.
-        ret[field.name] = encodeURIComponent(ret[field.name].replace(/"/g, '\\"'));
+        // Encode the content to play nicely within JSON.
+        ret[field.name] = encodeURIComponent(ret[field.name]);
       }
     }
   });
diff --git a/drupal7/sites/all/modules/media/modules/media_wysiwyg/js/wysiwyg-media.js b/drupal7/sites/all/modules/media/modules/media_wysiwyg/js/wysiwyg-media.js
index af99097b..d694b85b 100644
--- a/drupal7/sites/all/modules/media/modules/media_wysiwyg/js/wysiwyg-media.js
+++ b/drupal7/sites/all/modules/media/modules/media_wysiwyg/js/wysiwyg-media.js
@@ -20,7 +20,7 @@ Drupal.wysiwyg.plugins.media = {
    *   A DOM element
    */
   isNode: function(node) {
-    return $(node).is('img.media-element');
+    return $(node).is('img[data-media-element]');
   },
 
   /**
diff --git a/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.ckeditor.inc b/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.ckeditor.inc
index 236ef4bf..a00b1583 100644
--- a/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.ckeditor.inc
+++ b/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.ckeditor.inc
@@ -6,32 +6,20 @@
  */
 
 /**
- * Implements hook_ckeditor_plugin().
+ * Implements hook_ckeditor_plugin_alter().
  */
-function media_wysiwyg_ckeditor_plugin() {
-  return array(
-    'media' => array(
-      'name' => 'media',
-      'desc' => t('Plugin for inserting images from Drupal media module'),
-      'path' => base_path() . drupal_get_path('module', 'media_wysiwyg') . '/wysiwyg_plugins/media_ckeditor/',
-      'buttons' => array(
-        'Media' => array(
-          'icon' => 'images/icon.gif',
-          'label' => 'Add media',
-        ),
+function media_wysiwyg_ckeditor_plugin_alter(&$plugins) {
+  // Override the default CKEditor Media plugin.
+  $plugins['media'] = array(
+    'name' => 'media',
+    'desc' => t('Plugin for inserting images from Drupal media module'),
+    'path' => '%base_path%' . drupal_get_path('module', 'media_wysiwyg') . '/wysiwyg_plugins/media_ckeditor/',
+    'buttons' => array(
+      'Media' => array(
+        'icon' => 'images/icon.gif',
+        'label' => 'Add media',
       ),
-      'default' => 'f',
     ),
+    'default' => 'f',
   );
 }
-
-/**
- * Implements hook_ckeditor_plugin_alter().
- */
-function media_wysiwyg_ckeditor_plugin_alter(&$plugins) {
-  // To ensure the ckeditor media integration is done by this module all other
-  // integrations are overwritten here. However additionally added keys will be
-  // left intact.
-  $default_plugin = media_wysiwyg_ckeditor_plugin();
-  $plugins['media'] = $default_plugin['media'] + $plugins['media'];
-}
diff --git a/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.info b/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.info
index a88618bd..60191dea 100644
--- a/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.info
+++ b/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.info
@@ -15,9 +15,9 @@ files[] = tests/media_wysiwyg.macro.test
 
 configure = admin/config/media/browser
 
-; Information added by Drupal.org packaging script on 2014-10-04
-version = "7.x-2.0-alpha4"
+; Information added by Drupal.org packaging script on 2015-07-14
+version = "7.x-2.0-beta1"
 core = "7.x"
 project = "media"
-datestamp = "1412422430"
+datestamp = "1436895542"
 
diff --git a/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.install b/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.install
index 6d2d5e49..a0a0d798 100644
--- a/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.install
+++ b/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.install
@@ -18,3 +18,37 @@ function media_wysiwyg_uninstall() {
   variable_del('media_wysiwyg_wysiwyg_allowed_attributes');
   variable_del('media_wysiwyg_wysiwyg_browser_plugins');
 }
+
+/**
+ * Implements hook_update_dependencies().
+ */
+function media_wysiwyg_update_dependencies() {
+  // Ensure the "access media browser" permission is granted to users before
+  // using it to grant the "use media wysiwyg" permission.
+  $dependencies['media_wysiwyg'][7201] = array(
+    'media' => 7226,
+  );
+}
+
+/**
+ * Grant existing user access to new media wysiwyg permission.
+ */
+function media_wysiwyg_update_7201() {
+  $roles = user_roles(TRUE, 'access media browser');
+  foreach ($roles as $rid => $role) {
+    user_role_grant_permissions($rid, array('use media wysiwyg'));
+  }
+
+  return t('Use Media WYSIWYG permission was granted to: @roles.', array(
+    '@roles' => check_plain(implode(', ', $roles)),
+  ));
+}
+
+/**
+ * Use the legacy file entity rendering method for existing sites.
+ *
+ * Existing sites can change this setting at admin/config/media/browser.
+ */
+function media_wysiwyg_update_7202() {
+  variable_set('media_wysiwyg_default_render', 'field_attach');
+}
diff --git a/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.module b/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.module
index 1fb7a834..162e60bb 100644
--- a/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.module
+++ b/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.module
@@ -31,12 +31,14 @@ function media_wysiwyg_hook_info() {
  * Implements hook_menu().
  */
 function media_wysiwyg_menu() {
+  $items = array();
+
   $items['media/%file/format-form'] = array(
     'title' => 'Style selector',
     'description' => 'Choose a format for a piece of media',
     'page callback' => 'drupal_get_form',
     'page arguments' => array('media_wysiwyg_format_form', 1),
-    'access callback' => 'file_entity_access',
+    'access callback' => 'media_wysiwyg_access',
     'access arguments' => array('view', 1),
     'file' => 'includes/media_wysiwyg.pages.inc',
     'theme callback' => 'media_dialog_get_theme_name',
@@ -46,6 +48,27 @@ function media_wysiwyg_menu() {
   return $items;
 }
 
+/**
+ * Implements hook_permission().
+ */
+function media_wysiwyg_permission() {
+  return array(
+    'use media wysiwyg' => array(
+      'title' => t('Use Media WYSIWYG in an editor'),
+      // Marked restrict because the WYSIWYG forms generate image derivatives,
+      // which could lead to a DoS security vulnerability.
+      'restrict access' => TRUE,
+    ),
+  );
+}
+
+/**
+ * Access callback for WYSIWYG Media.
+ */
+function media_wysiwyg_access($op, $file = NULL, $account = NULL) {
+  return user_access('use media wysiwyg', $account) && file_entity_access($op, $file, $account);
+}
+
 /**
  * Implements hook_element_info_alter().
  */
@@ -53,6 +76,69 @@ function media_wysiwyg_element_info_alter(&$types) {
   $types['text_format']['#pre_render'][] = 'media_wysiwyg_pre_render_text_format';
 }
 
+/**
+ * Builds a map of media tags in the element.
+ *
+ * Builds a map of the media tags in an element that are being rendered to their
+ * rendered HTML. The map is stored in JS, so we can transform them when the
+ * editor is being displayed.
+ */
+function media_wysiwyg_pre_render_text_format($element) {
+  // filter_process_format() copies properties to the expanded 'value' child
+  // element.
+  if (!isset($element['format'])) {
+    return $element;
+  }
+
+  $field = &$element['value'];
+  $settings = array(
+    'field' => $field['#id'],
+  );
+
+  if (!isset($field['#value'])) {
+    return $element;
+  }
+
+  $tagmap = _media_wysiwyg_generate_tagMap($field['#value']);
+
+  if (isset($tagmap)) {
+    $element['#attached']['js'][] = array(
+      'data' => array(
+        'tagmap' => $tagmap,
+      ),
+      'type' => 'setting',
+    );
+  }
+
+  // Load the media browser library.
+  $element['#attached']['library'][] = array('media', 'media_browser');
+  $element['#attached']['library'][] = array('media', 'media_browser_settings');
+
+  // Add wysiwyg-specific settings.
+  $settings = array('wysiwyg_allowed_attributes' => variable_get('media_wysiwyg_wysiwyg_allowed_attributes', _media_wysiwyg_wysiwyg_allowed_attributes_default()));
+  $element['#attached']['js'][] = array(
+    'data' => array(
+      'media' => $settings,
+    ),
+    'type' => 'setting',
+  );
+
+  // Add filter handling.
+  $element['#attached']['js'][] = drupal_get_path('module', 'media_wysiwyg') . '/js/media_wysiwyg.filter.js';
+
+  // Add CKEditor-specific JS.
+  if (module_exists('ckeditor')) {
+    $element['#attached']['js'][] = array(
+      'data' => drupal_get_path('module', 'media_wysiwyg') . '/wysiwyg_plugins/media_ckeditor/library.js',
+      'type' => 'file',
+      'scope' => 'footer',
+      'weight' => -20,
+    );
+  }
+
+  return $element;
+}
+
 /**
  * Implements hook_form_FORM_ID_alter().
  */
@@ -121,6 +207,17 @@ function media_wysiwyg_form_media_admin_config_browser_alter(&$form, &$form_stat
     );
   }
 
+  $form['wysiwyg']['media_wysiwyg_default_render'] = array(
+    '#type' => 'radios',
+    '#title' => t('How should file entities be rendered within a text field?'),
+    '#description' => t("Full file entity rendering is the best choice for most sites. It respects the file entity's display settings specified at admin/structure/file-types. If your site already uses the legacy method, note that changing this option will affect your site's markup. Testing it on a non-production site is recommended."),
+    '#options' => array(
+      'file_entity' => 'Full file entity rendering',
+      'field_attach' => 'Legacy rendering (using field attach)',
+    ),
+    '#default_value' => variable_get('media_wysiwyg_default_render', 'file_entity'),
+  );
+
   $form['wysiwyg']['media_wysiwyg_wysiwyg_allowed_types'] = array(
     '#type' => 'checkboxes',
     '#title' => t('Allowed types in WYSIWYG'),
@@ -158,35 +255,6 @@ function media_wysiwyg_filter_info() {
   return $filters;
 }
 
-/**
- * Prepares the page to be able to launch the media browser.
- *
- * Defines default variables.
- */
-function media_wysiwyg_include_browser_js() {
-  static $included;
-  if ($included) {
-    return;
-  }
-  $included = TRUE;
-  module_load_include('inc', 'media', 'includes/media.browser');
-  $javascript = media_browser_js();
-  foreach ($javascript as $key => $definitions) {
-    foreach ($definitions as $definition) {
-      $function = 'drupal_add_' . $key;
-      // Since the arguments to pass are variable, use call_user_func_array().
-      // This will not handle all potential drupal_add_*() functions directly
-      // but covers the js and library needed here, which are unlikely to be
-      // expanded since this function is only a workaround for a wysiwyg
-      // limitation.
-      call_user_func_array($function, $definition);
-    }
-  }
-  // Add wysiwyg-specific settings.
-  $settings = array('wysiwyg_allowed_attributes' => variable_get('media_wysiwyg_wysiwyg_allowed_attributes', _media_wysiwyg_wysiwyg_allowed_attributes_default()));
-  drupal_add_js(array('media' => $settings), 'setting');
-}
-
 /**
  * Implements hook_wysiwyg_include_directory().
  */
diff --git a/drupal7/sites/all/modules/media/modules/media_wysiwyg/wysiwyg_plugins/media.inc b/drupal7/sites/all/modules/media/modules/media_wysiwyg/wysiwyg_plugins/media.inc
index a61c7134..9cd03bbd 100644
--- a/drupal7/sites/all/modules/media/modules/media_wysiwyg/wysiwyg_plugins/media.inc
+++ b/drupal7/sites/all/modules/media/modules/media_wysiwyg/wysiwyg_plugins/media.inc
@@ -9,16 +9,6 @@
  * Implements WYSIWYG's hook_INCLUDE_plugin().
  */
 function media_wysiwyg_media_plugin() {
-  // Include the required browser JS.
-  // @todo: wyswiyg should allow libraries and multiple js files
-  // to be defined by this hook.
-  // @see http://drupal.org/node/1039076
-  media_wysiwyg_include_browser_js();
-
-  // Add the filter handling.
-  drupal_add_js(drupal_get_path('module', 'media_wysiwyg') . '/js/media_wysiwyg.filter.js');
-
-  // Plugin definition.
   $plugins['media'] = array(
     'title' => variable_get('media_wysiwyg_wysiwyg_title', t('Media browser')),
     'vendor url' => 'http://drupal.org/project/media',
diff --git a/drupal7/sites/all/modules/media/modules/media_wysiwyg/wysiwyg_plugins/media_ckeditor/library.js b/drupal7/sites/all/modules/media/modules/media_wysiwyg/wysiwyg_plugins/media_ckeditor/library.js
index a1f33374..b097d170 100644
--- a/drupal7/sites/all/modules/media/modules/media_wysiwyg/wysiwyg_plugins/media_ckeditor/library.js
+++ b/drupal7/sites/all/modules/media/modules/media_wysiwyg/wysiwyg_plugins/media_ckeditor/library.js
@@ -13,7 +13,7 @@
      */
     invoke: function (data, settings, instanceId) {
       if (data.format == 'html') {
-        if (jQuery(data.node).is('.media-element')) {
+        if (jQuery(data.node).is('[data-media-element]')) {
           // Change the view mode for already-inserted media.
           var mediaFile = Drupal.media.filter.extract_file_info(jQuery(data.node));
           Drupal.media.popups.mediaStyleSelector(mediaFile, function (mediaFiles) {
diff --git a/drupal7/sites/all/modules/media/modules/media_wysiwyg_view_mode/media_wysiwyg_view_mode.info b/drupal7/sites/all/modules/media/modules/media_wysiwyg_view_mode/media_wysiwyg_view_mode.info
index 765a7a17..a17131e0 100644
--- a/drupal7/sites/all/modules/media/modules/media_wysiwyg_view_mode/media_wysiwyg_view_mode.info
+++ b/drupal7/sites/all/modules/media/modules/media_wysiwyg_view_mode/media_wysiwyg_view_mode.info
@@ -9,9 +9,9 @@ configure = admin/config/media/wysiwyg-view-mode
 
 files[] = media_wysiwyg_view_mode.test
 
-; Information added by Drupal.org packaging script on 2014-10-04
-version = "7.x-2.0-alpha4"
+; Information added by Drupal.org packaging script on 2015-07-14
+version = "7.x-2.0-beta1"
 core = "7.x"
 project = "media"
-datestamp = "1412422430"
+datestamp = "1436895542"
 
diff --git a/drupal7/sites/all/modules/media/modules/media_wysiwyg_view_mode/media_wysiwyg_view_mode.test b/drupal7/sites/all/modules/media/modules/media_wysiwyg_view_mode/media_wysiwyg_view_mode.test
index a51dc2fa..3d27e074 100644
--- a/drupal7/sites/all/modules/media/modules/media_wysiwyg_view_mode/media_wysiwyg_view_mode.test
+++ b/drupal7/sites/all/modules/media/modules/media_wysiwyg_view_mode/media_wysiwyg_view_mode.test
@@ -12,7 +12,7 @@ class MediaWYSIWYGViewModeTestHelper extends MediaWYSIWYGTestHelper {
   function setUp() {
     parent::setUp('media_wysiwyg_view_mode');
 
-    $web_user = $this->drupalCreateUser(array('administer media wysiwyg view mode', 'view files'));
+    $web_user = $this->drupalCreateUser(array('administer media wysiwyg view mode', 'view files', 'use media wysiwyg'));
     $this->drupalLogin($web_user);
   }
 }
diff --git a/drupal7/sites/all/modules/media/modules/mediafield/mediafield.info b/drupal7/sites/all/modules/media/modules/mediafield/mediafield.info
index ed00075c..d1ab05b6 100644
--- a/drupal7/sites/all/modules/media/modules/mediafield/mediafield.info
+++ b/drupal7/sites/all/modules/media/modules/mediafield/mediafield.info
@@ -4,9 +4,9 @@ package = Media
 core = 7.x
 dependencies[] = media
 
-; Information added by Drupal.org packaging script on 2014-10-04
-version = "7.x-2.0-alpha4"
+; Information added by Drupal.org packaging script on 2015-07-14
+version = "7.x-2.0-beta1"
 core = "7.x"
 project = "media"
-datestamp = "1412422430"
+datestamp = "1436895542"
 
diff --git a/drupal7/sites/all/modules/media/tests/includes/MediaModuleTest.inc b/drupal7/sites/all/modules/media/tests/includes/MediaModuleTest.inc
new file mode 100644
index 00000000..5e6c5d5e
--- /dev/null
+++ b/drupal7/sites/all/modules/media/tests/includes/MediaModuleTest.inc
@@ -0,0 +1,30 @@
+<?php
+
+/**
+ * @file
+ * Definition of MediaModuleTest.
+ */
+
+/**
+ * Test browser plugin.
+ */
+class MediaModuleTest extends MediaBrowserPlugin {
+  /**
+   * Implements MediaBrowserPluginInterface::access().
+   */
+  public function access($account = NULL) {
+    return TRUE;
+  }
+
+  /**
+   * Implements MediaBrowserPlugin::view().
+   */
+  public function view() {
+    $build = array();
+    $build['test'] = array(
+      '#markup' => '<p>' . t('Test browser plugin output.') . '</p>',
+    );
+
+    return $build;
+  }
+}
diff --git a/drupal7/sites/all/modules/media/tests/media.test b/drupal7/sites/all/modules/media/tests/media.test
index 97e99ef1..3594aaf0 100644
--- a/drupal7/sites/all/modules/media/tests/media.test
+++ b/drupal7/sites/all/modules/media/tests/media.test
@@ -468,6 +468,49 @@ class MediaAdminTestCase extends MediaFileFieldTestCase {
   }
 }
 
+/**
+ * Tests the media hooks.
+ */
+class MediaHooksTestCase extends MediaFileFieldTestCase {
+  public static function getInfo() {
+    return array(
+      'name' => 'Media hooks test',
+      'description' => 'Tests the Media hooks.',
+      'group' => 'Media',
+    );
+  }
+
+  function setUp() {
+    parent::setUp();
+  }
+
+  /**
+   * Tests that the media browser hooks.
+   */
+  function testMediaBrowserHooks() {
+    // Enable media_module_test.module's hook_media_browser_plugin_info()
+    // implementation and ensure it is working as designed.
+    variable_set('media_module_test_media_browser_plugin_info', TRUE);
+
+    $this->drupalGet('media/browser');
+    $this->assertRaw(t('Media module test'), 'Custom browser plugin found.');
+
+    // Enable media_module_test.module's hook_media_browser_plugin_info_alter()
+    // implementation and ensure it is working as designed.
+    variable_set('media_module_test_media_browser_plugin_info_alter', TRUE);
+
+    $this->drupalGet('media/browser');
+    $this->assertRaw(t('Altered plugin title'), 'Custom browser plugin was successfully altered.');
+
+    // Enable media_module_test.module's hook_media_browser_plugins_alter()
+    // implementation and ensure it is working as designed.
+    variable_set('media_module_test_media_browser_plugins_alter', TRUE);
+
+    $this->drupalGet('media/browser');
+    $this->assertRaw(t('Altered browser plugin output.'), 'Custom browser plugin was successfully altered before being rendered.');
+  }
+}
+
 /**
  * Tests the media browser 'Library' tab.
  */
@@ -870,15 +913,14 @@ class MediaElementSettingsTestCase extends MediaFileFieldTestCase {
     $javascript = $this->drupalGet("node/add/$type_name");
     $field_widget = array(
         'elements' => array(
-          '#edit-' . $field_name . '-' . LANGUAGE_NONE . '-0' => array(
+          '#edit-' . $field_name . '-' . LANGUAGE_NONE . '-0-upload' => array(
             'global' => array(
               'types' => array(
-                0 => 'image',
+                'image' => 'image',
               ),
               'enabledPlugins' => array(),
               'schemes' => array(
-                0 => 'public',
-                1 => 'private',
+                'public' => 'public',
               ),
               'file_directory' => '',
               'file_extensions' => 'txt',
diff --git a/drupal7/sites/all/modules/media/tests/media_module_test.info b/drupal7/sites/all/modules/media/tests/media_module_test.info
index 6e5b5416..e6267948 100644
--- a/drupal7/sites/all/modules/media/tests/media_module_test.info
+++ b/drupal7/sites/all/modules/media/tests/media_module_test.info
@@ -4,9 +4,11 @@ package = Media
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2014-10-04
-version = "7.x-2.0-alpha4"
+files[] = includes/MediaModuleTest.inc
+
+; Information added by Drupal.org packaging script on 2015-07-14
+version = "7.x-2.0-beta1"
 core = "7.x"
 project = "media"
-datestamp = "1412422430"
+datestamp = "1436895542"
 
diff --git a/drupal7/sites/all/modules/media/tests/media_module_test.module b/drupal7/sites/all/modules/media/tests/media_module_test.module
index d4add679..49c0c409 100644
--- a/drupal7/sites/all/modules/media/tests/media_module_test.module
+++ b/drupal7/sites/all/modules/media/tests/media_module_test.module
@@ -5,6 +5,48 @@
  * Provides Media module pages for testing purposes.
  */
 
+/**
+ * Implements hook_media_browser_plugin_info().
+ */
+function media_module_test_media_browser_plugin_info() {
+  // Allow tests to enable or disable this hook.
+  if (!variable_get('media_module_test_media_browser_plugin_info', FALSE)) {
+    return array();
+  }
+
+  $info['media_module_test'] = array(
+    'title' => t('Media module test'),
+    'class' => 'MediaModuleTest',
+    'weight' => 50,
+  );
+
+  return $info;
+}
+
+/**
+ * Implements hook_media_browser_plugin_info_alter().
+ */
+function media_module_test_media_browser_plugin_info_alter(&$info) {
+  // Allow tests to enable or disable this hook.
+  if (!variable_get('media_module_test_media_browser_plugin_info_alter', FALSE)) {
+    return;
+  }
+
+  $info['media_module_test']['title'] = t('Altered plugin title');
+}
+
+/**
+ * Implements hook_media_browser_plugins_alter().
+ */
+function media_module_test_media_browser_plugins_alter(&$plugin_output) {
+  // Allow tests to enable or disable this hook.
+  if (!variable_get('media_module_test_media_browser_plugins_alter', FALSE)) {
+    return;
+  }
+
+  $plugin_output['media_module_test']['test']['#markup'] = '<p>' . t('Altered browser plugin output.') . '</p>';
+}
+
 /**
  * Implements hook_menu().
  */
